<template>
  <q-page padding>
    <QuoteForm 
      componentHeading="Edit Quote"
      :id="id"
      @submit="submit" />
  </q-page>
</template>

<script>
import QuoteForm from "@/components/QuoteForm";
import showErrorNotification from '../notification/ErrorNotificationService';
import { useMeta } from 'quasar';

/**
 * This component provides a form for editing an existing quote.
 */
export default {

  components: {
    QuoteForm
  },

  setup() {
    useMeta(
      {
        title: "Edit"
      }
    )
  },

  data: function() {

    /**
     * ID of the quote that can be edited with this form
     */
    return {
      id: this.$route.params.id
    }
  },

  methods: {
    /**
     * Update the quote with the ID this.id.
     * The data of that quote is set to the values given by quoteData.
     * In the end the browser is sent to the scene with the list of all quotes.
     * 
     * @param {QuoteData} quoteData new data of the quote
     */
    async submit(quoteData) {
      let response;
      try {
        response = await this.$api.updateForId(
          this.id, 
          quoteData
        );
      } catch(error) {
        this.$log.debug(error);
        showErrorNotification("Failed to update quote content");
        return;
      }
      this.$log.info("Item updated:", response.data);
      this.$router.push({name: "List Quotes"});
    }
  }
}

</script>